unit Delete;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Mask, ToolEdit;

type
  TDelForm = class(TForm)
    DelDateEdit: TDateEdit;
    Label1: TLabel;
    DelButton: TButton;
    CancelButton: TButton;
    HelpButton: TButton;
    procedure CancelDelButtonClick(Sender: TObject);
    procedure DelButtonClick(Sender: TObject);
    procedure Purge;
    procedure FormActivate(Sender: TObject);
    procedure HelpButtonClick(Sender: TObject);
    
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DelForm: TDelForm;

implementation
uses
  main, list, help;

{$R *.DFM}

procedure TDelForm.CancelDelButtonClick(Sender: TObject);
begin
  Delete.DelForm.Close;
end;

procedure TDelForm.DelButtonClick(Sender: TObject);
var
  dDelDate : TDateTime;

begin
  if Application.MessageBox('   ?',' ',MB_OKCANCEL) = IDOK then
  begin

    dDelDate := DelDateEdit.Date;
    Purge;

    list.ListForm.TimeCTable.First;
    while not list.ListForm.TimeCTable.Eof do
    begin
      if list.ListForm.TimeCTableDATE.AsDateTime <= dDelDate
        then list.ListForm.TimeCTable.Delete
        else list.ListForm.TimeCTable.Next;
    end; {while not list.ListForm.TimeCTable.Eof do}
    ShowMessage('     :'#13#10+DateToStr(dDelDate));
    DelForm.Close;
    
  end; {Application.MessageBox(...) = IDOK then}
end;

procedure TDelForm.Purge;
var
  iUseDays,    iUseTVD    : Integer;
  iUseDaysMem, iUseTVDMem : Integer;

begin
  iUseDays    := 0;
  iUseTVD     := 0;

  //      
  list.ListForm.TimeCTable.First;
  while not list.ListForm.TimeCTable.Eof do
  begin
    if list.ListForm.TimeCTableDAYS.AsInteger < 0
      then iUseDays := iUseDays + abs(list.ListForm.TimeCTableDAYS.AsInteger);

    if list.ListForm.TimeCTableTVD.AsBoolean = True
      then if list.ListForm.TimeCTableDAYS.AsInteger < 0
        then iUseTVD := iUseTVD + abs(list.ListForm.TimeCTableDAYS.AsInteger);

    list.ListForm.TimeCTable.Next;

  end; {while not list.ListForm.TimeCTable.Eof do}

  iUseDaysMem := iUseDays;
  iUseTVDMem  := iUseTVD;

  list.ListForm.TimeCRxDBFilter.Active := True;

  //      

  list.ListForm.TimeCTable.First;
  
  while not list.ListForm.TimeCTable.Eof do
  begin
    if iUseTVD = 0 then break;

    if list.ListForm.TimeCTableTVD.AsBoolean = True then
    begin
      if list.ListForm.TimeCTableDAYS.AsInteger <= iUseTVD then
      begin
        iUseTVD := iUseTVD - list.ListForm.TimeCTableDAYS.AsInteger;
        list.ListForm.TimeCTable.Delete;
      end {if list.ListForm.TimeCTableDAYS.AsInteger < iUseTVD then}
      else
      begin
        list.ListForm.TimeCTable.Edit;
        list.ListForm.TimeCTableDAYS.AsInteger := list.ListForm.TimeCTableDAYS.AsInteger - iUseTVD;
        list.ListForm.TimeCTable.Post;
        iUseTVD := 0;
      end; {if list.ListForm.TimeCTableDAYS.AsInteger < iUseTVD else}
    end {if list.ListForm.TimeCTableTVD.AsBoolean = True then}
    else
    begin
      list.ListForm.TimeCTable.Next;
    end; {if list.ListForm.TimeCTableTVD.AsBoolean = True else}

  end; {while not list.ListForm.TimeCTable.Eof do}

  iUseTVDMem := iUseTVDMem - iUseTVD;

  //      
  list.ListForm.TimeCTable.First;
  while not list.ListForm.TimeCTable.Eof do
  begin
    if iUseDays = 0 then break;

    if list.ListForm.TimeCTableTVD.AsBoolean = False then
    begin
      if list.ListForm.TimeCTableDAYS.AsInteger < iUseDays then
      begin
        list.ListForm.TimeCTable.Edit;
        iUseDays := iUseDays - list.ListForm.TimeCTableDAYS.AsInteger;
        list.ListForm.TimeCTable.Post;
        list.ListForm.TimeCTable.Delete;
      end {if list.ListForm.TimeCTableDAYS.AsInteger < iUseDays then}
      else
      begin
        list.ListForm.TimeCTable.Edit;
        list.ListForm.TimeCTableDAYS.AsInteger := list.ListForm.TimeCTableDAYS.AsInteger - iUseDays;
        list.ListForm.TimeCTable.Post;
        iUseDays := 0;
      end; {if list.ListForm.TimeCTableDAYS.AsInteger < iUseDays else}
    end {if list.ListForm.TimeCTableTVD.AsBoolean = False then}
    else
    begin
      list.ListForm.TimeCTable.Next;
    end; {if list.ListForm.TimeCTableTVD.AsBoolean = False else}

  end; {while not list.ListForm.TimeCTable.Eof do}

  iUseDaysMem := iUseDaysMem - iUseDays;
  list.ListForm.TimeCRxDBFilter.Active := False;

  //   
  list.ListForm.TVDRxDBFilter.Active  := True;
  if iUseTVD = 0 then
  begin
    list.ListForm.DaysRxDBFilter.Active := True;
    list.ListForm.TimeCTable.First;
    while not list.ListForm.TimeCTable.Eof
      do list.ListForm.TimeCTable.Delete;
    list.ListForm.DaysRxDBFilter.Active := False;
  end {if iUseTVD = 0 then }
  else
  begin
    while not list.ListForm.TimeCTable.Eof do
    begin
      if iUseTVDMem > 0 then
      begin
        if abs(list.ListForm.TimeCTableDAYS.AsInteger) <= iUseTVDMem then
        begin
          iUseTVDMem := iUseTVDMem - abs(list.ListForm.TimeCTableDAYS.AsInteger);
          list.ListForm.TimeCTable.Delete;
        end {if abs(list.ListForm.TimeCTableDAYS.AsInteger) < iUseTVDMem then}
        else
        begin
          list.ListForm.TimeCTable.Edit;
          list.ListForm.TimeCTableDAYS.AsInteger := list.ListForm.TimeCTableDAYS.AsInteger + iUseTVDMem;
          list.ListForm.TimeCTable.Post;
          list.ListForm.TimeCTable.Next;
          iUseTVDMem := 0;
        end; {if abs(list.ListForm.TimeCTableDAYS.AsInteger) < iUseTVDMem else}
      end {if iUseTVDMem > 0 then}
      else
      begin
        list.ListForm.TimeCTable.Delete;
      end; {if iUseTVDMem > 0 else}
    end; {while not list.ListForm.TimeCTable.Eof do}
  end; {if iUseTVD = 0 else}

  list.ListForm.TVDRxDBFilter.Active  := False;

  //   
  list.ListForm.NotTVDRxDBFilter.Active  := True;
  if iUseDays = 0 then
  begin
    list.ListForm.DaysRxDBFilter.Active := True;
    list.ListForm.TimeCTable.First;
    while not list.ListForm.TimeCTable.Eof
      do list.ListForm.TimeCTable.Delete;
    list.ListForm.DaysRxDBFilter.Active := False;
  end {if iUseDays = 0 then }
  else
  begin
    while not list.ListForm.TimeCTable.Eof do
    begin
      if iUseDaysMem > 0 then
      begin
        if abs(list.ListForm.TimeCTableDAYS.AsInteger) <= iUseDaysMem then
        begin
          iUseDaysMem := iUseDaysMem - abs(list.ListForm.TimeCTableDAYS.AsInteger);
          list.ListForm.TimeCTable.Delete;
        end {if abs(list.ListForm.TimeCTableDAYS.AsInteger) < iUseDaysMem then}
        else
        begin
          list.ListForm.TimeCTable.Edit;
          list.ListForm.TimeCTableDAYS.AsInteger := list.ListForm.TimeCTableDAYS.AsInteger + iUseDaysMem;
          list.ListForm.TimeCTable.Post;
          list.ListForm.TimeCTable.Next;
          iUseDaysMem := 0;
        end; {if abs(list.ListForm.TimeCTableDAYS.AsInteger) < iUseDaysMem else}
      end {if iUseDaysMem > 0 then}
      else
      begin
        list.ListForm.TimeCTable.Delete;
      end; {if iUseDaysMem > 0 else}
    end; {while not list.ListForm.TimeCTable.Eof do}
  end; {if iUseDays = 0 else}

  list.ListForm.NotTVDRxDBFilter.Active  := False;

  main.MainForm.CalcSummDays;
  
end;

procedure TDelForm.FormActivate(Sender: TObject);
begin
  DelDateEdit.Date := Date;
end;

procedure TDelForm.HelpButtonClick(Sender: TObject);
begin
  if help.HelpForm.Visible = False
    then help.HelpForm.Show;

end;

end.
