unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  RXCtrls, StdCtrls, Mask, ToolEdit, CurrEdit, RXSpin, Db, DBTables;

type
  TMainForm = class(TForm)
    RxLabel1       : TRxLabel;
    RxLabel2       : TRxLabel;
    SummRxLabel    : TRxLabel;
    TVDRxLabel     : TRxLabel;
    AddButton      : TButton;
    SubButton      : TButton;
    AddDateEdit    : TDateEdit;
    AddRxSpinEdit  : TRxSpinEdit;
    AddEdit        : TEdit;
    AddCheckBox    : TCheckBox;
    ListButton     : TButton;
    HelpButton     : TButton;
    Label1         : TLabel;
    Label2         : TLabel;
    Label3         : TLabel;

    procedure HelpButtonClick(Sender: TObject);
    procedure ListButtonClick(Sender: TObject);
    procedure AddButtonClick (Sender: TObject);
    procedure FormActivate   (Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
    procedure CalcSummDays;
  end;

var
  MainForm: TMainForm;

implementation
uses
  list, help;

{$R *.DFM}


procedure TMainForm.HelpButtonClick(Sender: TObject);
begin
  if help.HelpForm.Showing = False then help.HelpForm.Show;
end;

procedure TMainForm.ListButtonClick(Sender: TObject);
begin
  if ListForm.Visible = False
    then ListForm.Show
    else ListForm.Close;
end;

procedure TMainForm.AddButtonClick(Sender: TObject);
var
  iDays     : Integer;     //  
begin

  if Sender = AddButton
    then iDays :=  AddRxSpinEdit.AsInteger
    else iDays := -AddRxSpinEdit.AsInteger;

  with list.ListForm.TimeCTable do
  begin
    Insert;
    list.ListForm.TimeCTableDATE.AsDateTime   := AddDateEdit.Date;
    list.ListForm.TimeCTableDAYS.AsInteger    := iDays;
    list.ListForm.TimeCTableCOMMENTS.AsString := AddEdit.Text;
    list.ListForm.TimeCTableTVD.AsBoolean     := AddCheckBox.Checked;
    Post;
  end;  {with list.ListForm.TimeCTable do}

  CalcSummDays;

end;   {procedure TMainForm.AddButtonClick(Sender: TObject)}

procedure TMainForm.CalcSummDays;
var
  iSummDays : Integer;
  iSummTVD  : Integer;
begin

  iSummDays := 0;
  iSummTVD  := 0;
  list.ListForm.TimeCTable.First;

  while not list.ListForm.TimeCTable.Eof do
  begin
    iSummDays := iSummDays + list.ListForm.TimeCTableDAYS.AsInteger;
    if list.ListForm.TimeCTableTVD.AsBoolean = True
      then iSummTVD := iSummTVD + list.ListForm.TimeCTableDAYS.AsInteger;
    list.ListForm.TimeCTable.Next;
  end;

  SummRxLabel.Caption := IntToStr(iSummDays);
  TVDRxLabel.Caption  := IntToStr(iSummTVD);
  
end; {procedure TMainForm.CalcSummDays;}

procedure TMainForm.FormActivate(Sender: TObject);
begin
  CalcSummDays;
  AddDateEdit.Date := Date;
end;

end.
